/* Gold Box Starter by Japo @ Abandonia.com
Allows Pool of Radiance to be run from any different folder every time (e.g. different DOSBox mount).
Redirect output to .CFG file.
*/

#include <stdio.h>
#include <dir.h>

void uppercase(char *c);

#define POSG 1
#define POSS 2
#define POS3 3

int main(int argc, char *argv[])
{
	char *param;
	char optg, opts, opt3;
	char curdir[MAXPATH];
	
	if(argc <= POSG)
		optg = 'E';
	else
	{
		param = argv[POSG]; /* graphic mode */
		optg = param[0];
		uppercase(&optg);
		switch(optg)
		{
			case 'E': /* EGA   */
			case 'C': /* CGA   */
			case 'T': /* Tandy */
				break;
			default:
				printf("Invalid graphic mode:\n%s\n", param);
				return POSG;
		}
	}
	if(argc <= POSS)
		opts = 'P';
	else
	{
		param = argv[POSS]; /* sound mode */
		opts = param[0];
		uppercase(&opts);
		switch(opts)
		{
			case 'P': /* PC speaker */
			case 'T': /* Tandy      */
			case 'S': /* Silent     */
				break;
			default:
				printf("Invalid sound mode:\n%s\n", param);
				return POSS;
		}
	}
	if(argc <= POS3)
		opt3 = 'F';
	else
	{
		param = argv[POS3]; /* sound mode */
		opt3 = param[0];
		uppercase(&opt3);
		switch(opt3)
		{
			case 'F':
			case 'N':
				break;
			default:
				printf("Invalid 3rd param:\n%s\n", param);
				return POS3;
		}
	}
	
	if(getcwd(curdir, MAXPATH) == NULL)
	{
		puts("Error retrieving current directory from DOS!");
		return 9;
	}
	/* If it happens to be a drive root, remove trailing '\' that will be added after.  */
	if(!curdir[3])
		curdir[2] = 0;

	printf("%c\n%c\n%s\\\n%s\\SAVE\\\n%c\n",
		optg, opts, curdir, curdir, opt3);
   return 0;
}

void uppercase(char *c)
{
	if(*c > 96)
		*c -= 32;
}